LootSquid = LibStub("AceAddon-3.0"):NewAddon("LootSquid",
    "AceConsole-3.0",
    "AceEvent-3.0",
    "AceTimer-3.0",
    "AceSerializer-3.0",
    "AceComm-3.0")

StaticPopupDialogs["LOOTSQUID_AWARD_LOOT"] = {
    text = "Transfer x to y?",
    button1 = "Yes",
    button2 = "No",
    OnAccept = function(popup)
    -- find candidate for current loot slot
        local shortPlayerName = Ambiguate(popup.playerName, "all")
        for k in pairs(_G["LootSquidSession"].loot) do
            if (_G["LootSquidSession"].loot[k].candidates
                    and _G["LootSquidSession"].loot[k].candidates[shortPlayerName]) then

                local ci = _G["LootSquidSession"].loot[k].candidates[shortPlayerName].candidateIndex

                if ci > 0 then
                    LootSquid:TransferLoot(_G["LootSquidSession"].currentLootSlot, ci)
                    LootSquid:ClearNeedAndGreeRequests()
                end
            end
        end

    --
    end,
    timeout = 30,
    whileDead = false,
    hideOnEscape = true,
    preferredIndex = 3, -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
}

_G["LootSquidSession"] = {
    loot = {},
    currentLootSlot = 0,
    playersNeeding = { },
    playersGreeding = { }
}

_G["LootSquidDebug"] = { alwaysParseLoot = false }

_G["LootSquidSettings"] = { lootThreshold = 0 }

_G["LootSquidFrames"] = { }

function LootSquid:strStartsWith(String, Start)
    return string.sub(String, 1, string.len(Start)) == Start
end

function LootSquid:strEndsWith(String, End)
    return End == '' or string.sub(String, -string.len(End)) == End
end

-- Sort a Table[] in Lua
-- http://stackoverflow.com/a/15706820
function LootSquid:spairs(t, order)
    -- collect the keys
    local keys = {}
    for k in pairs(t) do keys[#keys+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i]]
        end
    end
end


function LootSquid:OnInitialize()

--    precalculate api rating
    if _G["LootSquidData"] then
        if (_G["LootSquidData"].standings) then
            for k in pairs(_G["LootSquidData"].standings) do
                local standing = _G["LootSquidData"].standings[k].standing
                local itemsReceived = _G["LootSquidData"].standings[k].itemsReceived
                local apiRating = _G["LootSquidData"].standings[k].apiRating
                if (standing and itemsReceived) then
                    if (itemsReceived > 0) then
                        apiRating = standing / itemsReceived
                    else
                        apiRating = standing / 0.5
                    end
                    _G["LootSquidData"].standings[k].apiRating = apiRating
                end
            end
        else
            LootSquid:Print("Error: No standings available in LootSquidData.")
        end
    end

end

function LootSquid:OnEnable()
    LootSquid:RegisterEvents()

    --self:ScheduleTimer("TimerFeedback", 5)
end

function LootSquid:TimerFeedback()
    print("5 seconds passed")
end

function LootSquid:OnDisable()

end

_G["LootSquidFrames"].requestFrame = {}

function LootSquid:LootIconClick(lootIndex)
    --LootSquid:Print("Selecting lootIndex: " .. tostring(lootIndex))
end

function LootSquid:LootIconEnter(itemLink)
    GameTooltip:SetOwner(_G["LootSquidFrames"].requestFrame.frame, "ANCHOR_CURSOR")
    GameTooltip:SetHyperlink(itemLink)
    GameTooltip:Show()
end

function LootSquid:LootIconLeave()
    GameTooltip:Hide()
end

function LootSquid:TransferLoot(lootSlot, candidateIndex)
    GiveMasterLoot(lootSlot, candidateIndex)
end

-- http://stackoverflow.com/a/2705804
function LootSquid:tablelength(T)
    local count = 0
    for _ in pairs(T) do count = count + 1 end
    return count
end

function LootSquid:OpenLootGui()
    local AceGUI = LibStub("AceGUI-3.0")



    local f = AceGUI:Create("SimpleFrame")

    f:SetCallback("OnClose",
        function(widget)
            _G["LootSquidSession"].currentLootSlot = 0
            AceGUI:Release(widget)
        end)
    f:SetWidth(GetScreenWidth() * 0.6)
    f:SetHeight(GetScreenHeight() * 0.6)
    f:SetTitle("Loot Squid v0.1 Alpha - by Viggo (Darksun - Tarren Mill EU) - test")
    f:SetLayout("Flow")
    local backdrop = {
        bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
        edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
        tile = true,
        -- size (width or height) of the square repeating background tiles (in pixels)
        tileSize = 32,
        -- thickness of edge segments and square size of edge corners (in pixels)
        edgeSize = 3,
        -- distance from the edges of the frame to those of the background texture (in pixels)
        insets = {
            left = 3,
            right = 3,
            top = 3,
            bottom = 3
        }
    }

    f.frame:SetBackdrop(backdrop)
    f.frame:SetBackdropColor(0.1, 0.1, 0.1, 1)
    f.frame:SetBackdropBorderColor(0, 0, 0, 1)


    local topContainer = AceGUI:Create("SimpleGroup")
    topContainer:SetFullWidth(true)
    topContainer:SetHeight(200) -- probably?
    topContainer:SetLayout("Flow")
    f:AddChild(topContainer)

    local scroll = AceGUI:Create("ScrollFrame")
    scroll:SetRelativeWidth(0.5)
    scroll:SetHeight(200)
    scroll:SetLayout("Flow") -- probably?

    _G["LootSquidFrames"].lootFrame = scroll
    topContainer:AddChild(scroll)

    self:UpdateLootFrame()


    local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
    scrollcontainer:SetFullWidth(true)
    scrollcontainer:SetFullHeight(true) -- probably?
    scrollcontainer:SetLayout("Fill") -- important!
    f:AddChild(scrollcontainer)




    _G["LootSquidFrames"].requestFrame = scrollcontainer
    self:UpdateRequestFrame()
end

function LootSquid:OnUpdateLootTable()
    self:UpdateLootFrame()
end

function LootSquid:UpdateLootFrame()
    if (not _G["LootSquidFrames"].lootFrame) then
        return
    end

    local AceGUI = LibStub("AceGUI-3.0")


    _G["LootSquidFrames"].lootFrame:ReleaseChildren()

    for k in pairs(_G["LootSquidSession"].loot) do

        local v = _G["LootSquidSession"].loot[k]

        --[[
        -- loot[lootSlot] = {
            itemName = itemName,
            itemQuantity = itemQuantity,
            itemQuality = itemQuality,
            itemLocked = itemLocked,
            itemLootType = itemLootType,
            itemLink = itemLink,
            candidates = {}
        }]]

        local lootGroup = AceGUI:Create("SimpleGroup")
        lootGroup:SetLayout("Flow")

        local lootThreshold = GetLootThreshold()

        if v and v.itemLink and v.itemQuality >= lootThreshold then
            local icon = AceGUI:Create("Icon")
            icon:SetCallback("OnClick",
                function(widget)
                --LootSquid:LootIconClick(k)
                end)
            icon:SetCallback("OnEnter",
                function(widget)
                    LootSquid:LootIconEnter(v.itemLink)
                end)
            icon:SetCallback("OnLeave",
                function(widget)
                    LootSquid:LootIconLeave(v.itemLink)
                end)


            icon:SetLabel(v.itemName)
            icon:SetImageSize(40, 40)

            local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice =
                GetItemInfo(v.itemLink)


            icon:SetImage(texture)
            lootGroup:AddChild(icon)

            local button = AceGUI:Create("Button")
            button:SetText("Offer to raid")
            button:SetCallback("OnClick",
                function(widget)
                    LootSquid:ClearNeedAndGreeRequests()
                    _G["LootSquidSession"].currentLootSlot = k
                    SendChatMessage("LootSquid: --- Loot session starting ---",
                        "RAID")
                    SendChatMessage("LootSquid: do you need or greed " .. v.itemLink .. " ? - if so, write either !need <currentItem> or !greed <currentItem> in chat.",
                        "RAID")
                end)
            lootGroup:AddChild(button)

            button = AceGUI:Create("Button")
            button:SetText("Ninja loot!")
            button:SetCallback("OnClick",
                function(widget)
                end)
            lootGroup:AddChild(button)
        end

        _G["LootSquidFrames"].lootFrame:AddChild(lootGroup)
    end

end

function LootSquid:AddStandingsHeaderRow(frame)

    local AceGUI = LibStub("AceGUI-3.0")

    local row = AceGUI:Create("SimpleGroup")
    row:SetFullWidth(true)
    row:SetLayout("Flow")
    local height = AceGUI:Create("Label")
    height:SetHeight(150)
    height:SetRelativeWidth(0.01)
    row:AddChild(height)

    local backdropR = {
        bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
        edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
        tile = true,
        -- size (width or height) of the square repeating background tiles (in pixels)
        tileSize = 32,
        -- thickness of edge segments and square size of edge corners (in pixels)
        edgeSize = 2,
        -- distance from the edges of the frame to those of the background texture (in pixels)
        insets = {
            left = 1,
            right = 1,
            top = 1,
            bottom = -1
        }
    }

    row.frame:SetBackdrop(backdropR)
    row.frame:SetBackdropColor(0.15, 0.15, 0.15, 1)
    row.frame:SetBackdropBorderColor(0, 0, 0, 1)

    local label = AceGUI:Create("Label")
    label:SetText("Player")
    label:SetRelativeWidth(0.2)
    row:AddChild(label)

    label = AceGUI:Create("Label")
    label:SetText("Spec")
    label:SetRelativeWidth(0.1)
    row:AddChild(label)

    label = AceGUI:Create("Label")
    label:SetText("Role")
    label:SetRelativeWidth(0.1)
    row:AddChild(label)

    label = AceGUI:Create("Label")
    label:SetText("Current Item")
    label:SetRelativeWidth(0.1)
    row:AddChild(label)

    label = AceGUI:Create("Label")
    label:SetText("Attendance")
    label:SetRelativeWidth(0.09)
    row:AddChild(label)

    label = AceGUI:Create("Label")
    label:SetText("Items Recv.")
    label:SetRelativeWidth(0.08)
    row:AddChild(label)

    label = AceGUI:Create("Label")
    label:SetText("API")
    label:SetRelativeWidth(0.1)
    row:AddChild(label)

    label = AceGUI:Create("Label")
    label:SetText("Actions")
    label:SetRelativeWidth(0.2)
    row:AddChild(label)

    frame:AddChild(row)
end

function LootSquid:GetStandingsByPlayerName(playerName)
    if (_G["LootSquidData"].standings and _G["LootSquidData"].standings[playerName]) then
        local standing = _G["LootSquidData"].standings[playerName].standing
        local itemsReceived = _G["LootSquidData"].standings[playerName].itemsReceived
        local apiRating = _G["LootSquidData"].standings[playerName].apiRating
        return standing, itemsReceived, apiRating
    end
    return nil
end

function LootSquid:SortStandingsByApiRating(a, b)
    local aStanding, aItemsReceived, aApiRating = LootSquid:GetStandingsByPlayerName(a)
    local bStanding, bItemsReceived, bApiRating = LootSquid:GetStandingsByPlayerName(b)

    if aApiRating and not bApiRating then
        return true
    end

    if bApiRating and not aApiRating then
        return false
    end

    if not aApiRating and not bApiRating then
        return true
    end

    if aApiRating > bApiRating then
        return true
    end

    return false
end

function LootSquid:AddStandingsDataRows(frame, needingOrGreedingPlayers)

    local AceGUI = LibStub("AceGUI-3.0")

    for k in self:spairs(needingOrGreedingPlayers,
        function(t,a,b) return self:SortStandingsByApiRating(a, b) end
    ) do

        local row = AceGUI:Create("SimpleGroup")
        row:SetFullWidth(true)
        row:SetLayout("Flow")
        local height = AceGUI:Create("Label")
        height:SetHeight(150)
        height:SetRelativeWidth(0.01)
        row:AddChild(height)

        local backdropR = {
            bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
            edgeFile = "Interface\\ChatFrame\\ChatFrameBackground",
            tile = true,
            -- size (width or height) of the square repeating background tiles (in pixels)
            tileSize = 32,
            -- thickness of edge segments and square size of edge corners (in pixels)
            edgeSize = 2,
            -- distance from the edges of the frame to those of the background texture (in pixels)
            insets = {
                left = 1,
                right = 1,
                top = 1,
                bottom = -1
            }
        }

        row.frame:SetBackdrop(backdropR)

        row.frame:SetBackdropColor(0.2, 0.2, 0.2, 1)
        row.frame:SetBackdropBorderColor(0, 0, 0, 1)

        --if i < 4 then

        --   row.frame:SetBackdropBorderColor(0,1,0,1)
        --else
        --   row.frame:SetBackdropBorderColor(1,1,0,1)
        --end

        local standing = 0
        local itemsReceived = 0
        local apiRating = 0

        if (_G["LootSquidData"].standings and _G["LootSquidData"].standings[k]) then
            standing = _G["LootSquidData"].standings[k].standing
            itemsReceived = _G["LootSquidData"].standings[k].itemsReceived
            apiRating = _G["LootSquidData"].standings[k].apiRating
        else
            --LootSquid:Print("No standings for player name: "..tostring(k))
        end

        local label = AceGUI:Create("Label")
        label:SetText(k)
        label:SetRelativeWidth(0.2)
        row:AddChild(label)

        label = AceGUI:Create("Label")
        label:SetText("-")
        label:SetRelativeWidth(0.1)
        row:AddChild(label)

        label = AceGUI:Create("Label")
        label:SetText("-")
        label:SetRelativeWidth(0.1)
        row:AddChild(label)

        label = AceGUI:Create("Icon")
        --label:SetText("Current Item")
        label:SetRelativeWidth(0.1)
        row:AddChild(label)

        label = AceGUI:Create("Label")
        label:SetText(standing)
        label:SetRelativeWidth(0.08)
        row:AddChild(label)

        label = AceGUI:Create("Label")
        label:SetText(itemsReceived)
        label:SetRelativeWidth(0.09)
        row:AddChild(label)

        label = AceGUI:Create("Label")
        label:SetText(apiRating)
        label:SetRelativeWidth(0.1)
        row:AddChild(label)

        local actions = AceGUI:Create("SimpleGroup")
        actions:SetRelativeWidth(0.2)
        actions:SetLayout("Flow")
        actions.frame:SetBackdrop(nil)


        local button = AceGUI:Create("Button")
        button:SetFullWidth(true)
        button:SetHeight(20)
        button:SetText("Award")
        button:SetCallback("OnClick",
            function()
                local popup = StaticPopup_Show("LOOTSQUID_AWARD_LOOT", k)
                if popup then
                    popup.playerName = k
                end
            end)
        actions:AddChild(button)

        button = AceGUI:Create("Button")
        button:SetFullWidth(true)
        button:SetHeight(20)
        button:SetText("Whisper for roll")
        button:SetCallback("OnClick", function()
            SendChatMessage("LootSquid: The loot master has requested that you please perform a random roll as part of the loot distribution.",
                "WHISPER",
                nil,
                k)
        end)

        actions:AddChild(button)
        row:AddChild(actions)




        frame:AddChild(row)
    end
end

function LootSquid:UpdateRequestFrame()

    if (not _G["LootSquidFrames"].requestFrame) then
        return
    end

    local AceGUI = LibStub("AceGUI-3.0")


    _G["LootSquidFrames"].requestFrame:ReleaseChildren()


    local scroll = AceGUI:Create("ScrollFrame")
    scroll:SetLayout("List") -- probably?
    _G["LootSquidFrames"].requestFrame:AddChild(scroll)

    self:AddStandingsHeaderRow(scroll)

    local label = AceGUI:Create("InteractiveLabel")
    label:SetText("Players Needing")
    label:SetColor(0.1, 0.8, 0.1)
    label:SetRelativeWidth(1)
    label:SetImageSize(40, 40)
    label:SetHeight(40)
    scroll:AddChild(label)

    --label.frame:SetParent(frame)


    self:AddStandingsDataRows(scroll, _G["LootSquidSession"].playersNeeding)



    label = AceGUI:Create("InteractiveLabel")
    label:SetText("Players Greeding")
    label:SetColor(0.8, 0.8, 0.1)
    label:SetRelativeWidth(1)
    label:SetImageSize(40, 40)
    label:SetHeight(40)
    scroll:AddChild(label)

    self:AddStandingsDataRows(scroll, _G["LootSquidSession"].playersGreeding)
end

function LootSquid:ClearNeedAndGreeRequests()
    _G["LootSquidSession"].playersNeeding = {}
    _G["LootSquidSession"].playersGreeding = {}
    LootSquid:UpdateRequestFrame()
end